/* Fianchetto 0.0 - main.c - 
   Copyright (c) 2003 Ignacio Garca Fernndez

   Fianchetto is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Fianchetto is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Fianchetto; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info: ignacio.garcia@uv.es
*/
#include "tourney.h"

#include <stdlib.h>
#include <stdio.h>
#include <getopt.h>


FILE *fich;
char optString[] = "f:n:h";
char filename[128];
int
mngInput(int argc,char *argv[]);

t_tourney tourney;

int filename_set=0;
int nrounds_set;

int main(int argc,char *argv[])
{


  int i,round;

  clear_tourney(&tourney);

  mngInput(argc,argv); 


  if(!filename_set)
    {
      printf("Ruta del fichero de jugadores\n");
      scanf("%s",filename);
    }
  fich = fopen(filename,"r");

  if(!nrounds_set)
    {
      printf("Nmero de rondas:\n");
      scanf("%d",&tourney.n_rounds);
    }

  tourney.players = read_player_file(fich,&(tourney.n_players));

  init_tourney(&tourney);

  printf("Jugadores\n");
  for(i=0;i<tourney.n_players;i++)
    printf("Jugador %d: %s,\tRating: %d,\tTtulo: %d,\tScore: %d\n",
	   tourney.players[i].Id,tourney.players[i].name,
	   tourney.players[i].rating,tourney.players[i].title,
	   tourney.players[i].score);

  printf("El torneo va a comenzar. Espere, por favor...\n*************\n");

  printf("\n\n\n\n\n\n\n");

  for(round=0;round<tourney.n_rounds;round++)
    {
      tourney.round=round;
      next_round(&tourney);

      printf("\n\nA medida que se vayan produciendo los resultados introdzcalos por teclado.\n\n");
      read_results(tourney.pairs,tourney.n_players/2);

      printf("Puntuacin tras la ronda %d.\n",round);
      for(i=0;i<tourney.n_players;i++)
	printf("Jugador: %s,\tRating: %d,\tTtulo: %d,\tScore: %0.1f\n",tourney.players[i].name,tourney.players[i].rating,tourney.players[i].title,tourney.players[i].score*0.5);
      printf("Jugadores\n");

    }
  return 0;
}


int
mngInput(int argc,char *argv[])
{
int opt;
extern char 	*optarg;
extern int 	optind;

  while ((opt = getopt(argc,argv,optString)) != -1)
    {
      switch(opt)
	{
	case 'f':
	  strcpy(filename,optarg);
	  printf("%s",filename);
	  fflush(stdout);
	  filename_set = 1;
	  break;

	case 'n':
	  tourney.n_rounds = atoi(optarg);
	  nrounds_set = 1;
	  break;

	case 'h':
	  printf ("fianchetto\n");
	  break;

	}
    }
  return 0;
}



