/* Fianchetto 0.0 - players.h - 
   Copyright (c) 2003 Ignacio Garca Fernndez

   Fianchetto is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Fianchetto is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Fianchetto; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info: ignacio.garcia@uv.es
*/

#define END_GAME 0
#define MAX_ROUND 1
#define NUM 4
#define NUM_FIELDS 3
#define NAME 0
#define RATING 1
#define TITLE 2


#include<stdio.h>

struct s_player {
  char name[20];
  int Id;
  int rating;
  int score;
  int title;
  int games;
  int wins;
  int losses;
  int draws;
  int forfeits;
  int abuse;
  int *played;
  long updatetime;
  struct s_dbplayer *next;
  struct s_dbplayer *prev;
};

typedef struct s_player t_player;

struct s_pair {
  int check;
  t_player *white;
  t_player *black;
};

typedef struct s_pair t_pair;

void clear_plyr(t_player *pl);
void sort_players(t_player *players,int numplayers);
int compare_name(const t_player *p1,const t_player *p2);
int compare_title(const t_player *p1,const t_player *p2);
int compare_rating(const t_player *p1,const t_player *p2);
int compare_plyrs(const t_player *p1,const t_player *p2);
t_player* read_player_file(FILE *fich,int *n);
int store_field(int f_num,int len,char *data,t_player *pl);

