/* Fianchetto 0.0 - tourney.c - 
   Copyright (c) 2003 Ignacio Garca Fernndez

   Fianchetto is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Fianchetto is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Fianchetto; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info: ignacio.garcia@uv.es
*/
#include<stdlib.h>
#include"tourney.h"


int next_round(t_tourney *t)
{
  int num_brackets,brkt;
  int player_nr,last_nplyrs=0;

  printf("Empieza la ronda %d\n",t->round+1);

  num_brackets = 2*t->round+1;

  t->br_list = (t_bracket *) calloc(sizeof(t_bracket),num_brackets);

  /* group players acording to their score */

  sort_players(t->players,t->n_players);

  /* the following loop finds brackets */

  player_nr = 0;

  for(brkt=0;brkt<num_brackets;brkt++)
    {
      t->br_list[brkt].score = num_brackets - brkt - 1;
      t->br_list[brkt].start = &t->players[player_nr];

      if(t->players[player_nr].score>=t->br_list[brkt].score)
	{ /* there is at least one player in this bracket */

	  while(t->players[player_nr].score>=t->br_list[brkt].score && player_nr < t->n_players)
	    player_nr++;

	  t->br_list[brkt].n_players = player_nr - last_nplyrs;

	  if(t->br_list[brkt].n_players%2)
	    {
	      t->br_list[brkt].n_players--;

	      player_nr--;


	      if(brkt!=num_brackets-1)
		t->br_list[brkt+1].p++;

	      printf("Downfloat!\n");

	    }
	  if(!t->br_list[brkt].p)
	    t->br_list[brkt].p = t->br_list[brkt].n_players/2;
	  else
	    t->br_list[brkt].x = t->br_list[brkt].n_players - 2*t->br_list[brkt].p;
	  last_nplyrs = player_nr;
	}
    }
  t->pairs = pair(t);
  return 0;
}


t_pair * pair(t_tourney *t)
{
  int i,j,board=0;
  t_pair *p;
  int n;
  t_player *white,*black;

  n = 2*t->round+1;

  p = (t_pair *) calloc(sizeof(t_pair),t->n_players/2);

  for(i=0;i<n;i++)
    {
      for(j=0;j<t->br_list[i].p;j++)
	{


	  white = &t->br_list[i].start[j];
	  black = &t->br_list[i].start[t->br_list[i].p+j];

	  white->played[t->round] = black->Id;
	  black->played[t->round] = white->Id;

	  p[board].white = white;
	  p[board].black = black;

	  board++;
	}

      if(t->br_list[i].x)
	{
	  for(j=0;j<t->br_list[i].x/2;j++)
	    {

	      white = &t->br_list[i].start[t->br_list[i].p*2 + j];
	      black = &t->br_list[i].start[t->br_list[i].p*2 + t->br_list[i].x/2+j];

	      white->played[t->round] = black->Id;
	      black->played[t->round] = white->Id;

	      p[board].white = white;
	      p[board].black = black;

	      board++;
	    }
	  
	}
    }

  board = 0;
  printf("board\t w\t b\n");
  for(i=0;i<n;i++)
    for(j=0;j<t->n_players/2;j++)
      {
	printf("%d\t%s\t%s\n",board,p[board].white->name,p[board].black->name);
	board++;
      }

  return p;
}

void
read_results(t_pair *p,int n)
{
  int boards_ok=0;
  int board;
  float res;

  while(boards_ok<n)
    {
      printf("\n*****************\nIntoduce el nmero de tablero: ");
      scanf("%d",&board);

      if(p[board-1].check==1)
	printf("Resultado ya introducido\n");
      else
	{
	  boards_ok++;

	  res = -1;
	  while(res!=0 && res!=0.5 && res!=1)
	    {
	      printf("Intoduce el resultado:\n\t0 - White wins\n\t0.5 - Draw\n\t1 - Black wins\n");
	      scanf("%f",&res);
	    }      

	  p[board-1].white->score += 2 - (int) 2*res;
	  p[board-1].black->score += (int) 2*res;
	  p[board-1].check=1;
	}
    }
}

void
clear_tourney(t_tourney *t)
{
  t->n_rounds = 0;
  t->round = 0;
  t->n_players = 0;
  t->players = NULL;
}

void init_tourney(t_tourney *t)
{
  int i;

  sort_players(t->players,t->n_players);

  for(i=0;i<t->n_players;i++)
    {
      t->players[i].Id = i;
      t->players[i].played = (int *) calloc(sizeof(int),t->n_rounds);
    }
}
